# -*- coding: utf-8 -*-
from setuphelpers import *
from waptpackage import control_to_dict
import codecs

uninstallkey = []

def install():

    run_notfatal('apt-get remove calibre -y')
    run_notfatal('apt-get autoremove -y')
    print('installing Calibre')
    version_calibre = control.version.split('-')[0]
    if isdir('/opt/calibre'):
        remove_tree('/opt/calibre')
    mkdirs('/opt/calibre')
    run('tar -xf calibre-%s-x86_64.txz -C /opt/calibre' % control.version.split('-')[0])
    run('chown -R root:root /opt/calibre')
    run('ln -sf /opt/calibre/calibre /usr/bin/calibre')
    run('ln -sf /opt/calibre/ebook-edit /usr/bin/ebook-edit')
    run('ln -sf /opt/calibre/ebook-viewer /usr/bin/ebook-viewer')
    run('ln -sf /opt/calibre/bin/lrfviewer /usr/bin/lrfviewer')
    run('cp -f *.desktop /usr/share/applications/')


def uninstall():
    run('unlink /usr/bin/calibre')
    run('unlink /usr/bin/ebook-edit')
    run('unlink /usr/bin/ebook-viewer')
    run('unlink /usr/bin/lrfviewer')

    remove_tree('/opt/calibre')
    run('rm -f /usr/share/applications/calibre*.desktop')

def update_package():
    import re
    import json

    proxies = {}
    if isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxies = {'http':proxywapt,'https':proxywapt}

    v = [(str(p['browser_download_url'])) for p in json.loads(wgets('https://api.github.com/repos/kovidgoyal/calibre/releases/latest',proxies=proxies))['assets'] if '.exe' in p['name']][0].split('/')[-2]
    urlfile = 'https://github.com/kovidgoyal/calibre/releases/download/%s/calibre-%s-x86_64.txz' % (v,v.strip('v'))
    filename = urlfile.rsplit('/',1)[-1]

    exes = glob.glob('*.txz')
    for fn in exes:
        if fn != filename:
            remove_file(fn)

    if not isfile(filename):
        print('Downloading %s from %s'%(filename,urlfile))
        wget(urlfile,filename,proxies=proxies)
    else:
        print('Already up to date, skipped')

    control.version = v.strip('v') + '-0'
    control.save_control_to_wapt()
